// EditDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "birthday.h"
#include "birthdayDlg.h"
#include "EditDlg.h"
#include "Key.h"
#include "PortDlg.h"
#include "BalloonHelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CEditDlg


CEditDlg::CEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditDlg)
	//}}AFX_DATA_INIT
}


void CEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditDlg)
	DDX_Control(pDX, IDC_EDIT_INFO_VERSION, m_edit_info_version);
	DDX_Control(pDX, IDC_EDIT_INFO_TITLE, m_edit_info_title);
	DDX_Control(pDX, IDC_EDIT_INFO_AUTHOR, m_edit_info_author);
	DDX_Control(pDX, IDC_EDIT_DATE_YEAR, m_edit_date_year);
	DDX_Control(pDX, IDC_EDIT_DATE_MOTH, m_edit_date_month);
	DDX_Control(pDX, IDC_EDIT_DATE_DAY, m_edit_date_day);
	DDX_Control(pDX, IDOK, m_button_save);
	DDX_Control(pDX, IDC_BUTTON_EDIT_DELETE, m_button_edit_delete);
	DDX_Control(pDX, IDC_BUTTON_EDIT_CHANGE, m_button_edit_change);
	DDX_Control(pDX, IDC_BUTTON_EDIT_ADD, m_button_edit_add);
	DDX_Control(pDX, IDC_EDIT_FOR, m_edit_for);
	DDX_Control(pDX, IDC_EDIT_BACK, m_edit_back);
	DDX_Control(pDX, IDC_LABEL_BACK, m_label_back);
	DDX_Control(pDX, IDC_LABEL_FOR, m_label_for);
	DDX_Control(pDX, IDC_EDIT_NAME, m_edit_data_name);
	DDX_Control(pDX, IDC_EDIT_EVENT, m_edit_data_event);
	DDX_Control(pDX, IDC_LIST_DATA, m_list_data);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditDlg, CDialog)
	//{{AFX_MSG_MAP(CEditDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_DATA, OnItemchangedListData)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_CHANGE, OnButtonEditChange)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_ADD, OnButtonEditAdd)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_DELETE, OnButtonEditDelete)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_RELOAD, OnButtonEditReload)
	ON_BN_CLICKED(IDC_BUTTON_SELFILE, OnButtonSelfile)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_DELETEALL, OnButtonEditDeleteall)
	ON_WM_SYSCOMMAND()
	ON_WM_MOVING()
	ON_WM_SIZE()
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_BUTTON_IMPORT, OnButtonImport)
	ON_BN_CLICKED(IDC_BUTTON_EXPORT, OnButtonExport)
	ON_NOTIFY(LVN_KEYDOWN, IDC_LIST_DATA, OnKeydownListData)
	ON_EN_SETFOCUS(IDC_EDIT_NAME, OnSetfocusEditName)
	ON_EN_KILLFOCUS(IDC_EDIT_NAME, OnKillfocusEditName)
	ON_EN_CHANGE(IDC_EDIT_DATE_DAY, OnChangeEditDateDay)
	ON_EN_CHANGE(IDC_EDIT_DATE_MOTH, OnChangeEditDateMoth)
	ON_EN_CHANGE(IDC_EDIT_INFO_TITLE, OnChangeEditInfoTitle)
	ON_EN_CHANGE(IDC_EDIT_INFO_AUTHOR, OnChangeEditInfoAuthor)
	ON_EN_CHANGE(IDC_EDIT_INFO_VERSION, OnChangeEditInfoVersion)
	ON_NOTIFY(NM_RCLICK, 0, OnHeaderItemclickListData)
	ON_WM_VSCROLL()
	ON_WM_KEYDOWN()
	ON_EN_SETFOCUS(IDC_EDIT_EVENT, OnSetfocusEditName)
	ON_EN_SETFOCUS(IDC_EDIT_DATE_DAY, OnSetfocusEditName)
	ON_EN_SETFOCUS(IDC_EDIT_DATE_MOTH, OnSetfocusEditName)
	ON_EN_SETFOCUS(IDC_EDIT_DATE_YEAR, OnSetfocusEditName)
	ON_EN_KILLFOCUS(IDC_EDIT_DATE_DAY, OnKillfocusEditName)
	ON_EN_KILLFOCUS(IDC_EDIT_DATE_MOTH, OnKillfocusEditName)
	ON_EN_KILLFOCUS(IDC_EDIT_DATE_YEAR, OnKillfocusEditName)
	ON_EN_KILLFOCUS(IDC_EDIT_EVENT, OnKillfocusEditName)
	ON_COMMAND(IDM_SORTDATEBY_DAY, OnMenuSortdatebyDay)
	ON_COMMAND(IDM_DATESORT_YEAR, OnMenuDatesortYear)
	ON_COMMAND(IDM_SORTDATEBY_MONTH, OnMenuSortdatebyMonth)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CEditDlg

BOOL CEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	IsLoaded = false;

/*	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->InsertMenu(1,MF_SEPARATOR);
			Loader.LoadString(IDS_ALWAYSONTOP);
		if(IsOnTop)
			pSysMenu->InsertMenu(1,MF_CHECKED,IDM_MNU_ONTOP, Loader);
		else
			pSysMenu->InsertMenu(1,MF_UNCHECKED,IDM_MNU_ONTOP, Loader);

			Loader.LoadString(IDS_MAGNETBORDER);
		if(IsMagnetOn)
			pSysMenu->InsertMenu(1,MF_CHECKED,IDM_MNU_MAGNET, Loader);
		else
			pSysMenu->InsertMenu(1,MF_UNCHECKED,IDM_MNU_MAGNET, Loader);
	}
*/
	MagnetSize = 20;
	IsLoaded = false;

	m_edit_data_name.ACCutSymbols = " -+:;!\"&$()=?*~#,./|<>";
	m_edit_data_event.ACCutSymbols = " -+:;!\"&$()=?*~#,./|<>";

	Loader.LoadString(IDS_AC_NAMES);
	m_edit_data_name.ACWordGroup = " " + Loader + " ";
	Loader.LoadString(IDS_AC_EVENTS);
	m_edit_data_event.ACWordGroup = " " + Loader + " ";

	Loader.Format("%d", ActBirthFile.ShowLast);
	m_edit_back.SetWindowText( Loader);
	Loader.Format("%d", ActBirthFile.ShowNext);
	m_edit_for.SetWindowText( Loader);

	Loader.LoadString(IDS_E_SLIDER_BACK);
	m_label_back.SetWindowText(Loader);
	Loader.LoadString(IDS_E_SLIDER_FOR);
	m_label_for.SetWindowText(Loader);


	m_edit_info_title.SetWindowText( ActBirthFile.Title);
	m_edit_info_author.SetWindowText( ActBirthFile.Author);
	m_edit_info_version.SetWindowText( ActBirthFile.Version);


	SmallIcons.Create(16, 16, TRUE, 10, 10);
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_STAR));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_YELLOW));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_GREEN));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_BLUE));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_1));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_2));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_3));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_M1));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_M2));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_M3));
	m_list_data.SetImageList( &SmallIcons, LVSIL_SMALL);

	CreateListHeaders();
	ListOut();
	if(atof(ActBirthFile.FileVersion) > 1)
	{
		Loader.LoadString(IDS_MSG_WRONGVERSION);
		MessageBox(Loader, "Warning", MB_ICONEXCLAMATION);
	}

	m_edit_date_day.SetLimitText(2);
	m_edit_date_month.SetLimitText(2);
	m_edit_date_year.SetLimitText(4);

	CEditDlg::ShowWindow( SW_NORMAL);
	if( bAutoEdit)
	{
		Loader.LoadString( IDS_MSG_AUTOEDIT);
		MessageBox( Loader, MSGBOXTITLE, MB_ICONINFORMATION);
		m_edit_data_name.SetFocus();
	}
	else//give the name field the focus!
		m_edit_data_name.SetFocus();

	return false;
}

void CEditDlg::CreateListHeaders()//Adding Headers to ListCtrl
{

	CString strAll;
	Loader.LoadString(IDS_LIST_HEADER_DAYDIFF);
	strAll += Loader + ",43;";
	Loader.LoadString(IDS_LIST_HEADER_YEARDIFF);
	strAll += Loader + ",34;";
	Loader.LoadString(IDS_LIST_HEADER_NAME);
	strAll += Loader + ",250;";
	Loader.LoadString(IDS_LIST_HEADER_EVENT);
	strAll += Loader + ",118;";
	Loader.LoadString(IDS_LIST_HEADER_DATE);
	strAll += Loader + ",67;num,0";

	//| LVS_EX_FLATSB
	m_list_data.SetExtendedStyle(LVS_EX_FULLROWSELECT );
	m_list_data.SetHeadings( strAll );
	m_list_data.LoadColumnInfo();

	
	bSomethingChanged = false;
}

void CEditDlg::ListOut()  //Output: Data to ListCtrl
{
//	CString buffer, buffer2, ShowYear;
	m_list_data.DeleteAllItems();

	CString buffer, buffer2, ShowYear;
	int ActImage;
	LPTSTR extra;
	for(int a=0; a <= ActBirthFile.CountPersons; a++)
	{
			if(ActBirthFile.ActBirthPersons[a].daydifflast <= ActBirthFile.ShowLast && ActBirthFile.ActBirthPersons[a].daydifflast > 0)
			{
				buffer2.Format("%d", ActBirthFile.ActBirthPersons[a].daydifflast);
				buffer2 = "0" + buffer2;
				buffer.Format("%d", 1000 - ActBirthFile.ActBirthPersons[a].daydifflast);
				buffer = "0" + buffer;
				extra = "-";
				if(ActBirthFile.ActBirthPersons[a].daydifflast == 1)
					ActImage = 7;
				else if(ActBirthFile.ActBirthPersons[a].daydifflast == 2)
					ActImage = 8;
				else if(ActBirthFile.ActBirthPersons[a].daydifflast == 3)
					ActImage = 9;
				else
					ActImage = 3;
				ShowYear.Format("%d",ActBirthFile.ActBirthPersons[a].yeardiff - 1);
			}
			else
			{
				buffer.Format("%d", ActBirthFile.ActBirthPersons[a].daydiffnext);
				buffer = "1" + buffer;
				buffer2 = buffer;
				extra = "";

				if(ActBirthFile.ActBirthPersons[a].daydiffnext == 0)
					ActImage = 0;
				else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 1)
					ActImage = 4;
				else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 2)
					ActImage = 5;
				else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 3)
					ActImage = 6;
				else if(ActBirthFile.ActBirthPersons[a].daydiffnext <= 10)
					ActImage = 1;
				else
					ActImage = 2;

				ShowYear.Format("%d",ActBirthFile.ActBirthPersons[a].yeardiff);
			}

		if(ActBirthFile.ActBirthPersons[a].Date.year.Right(1) == "?")
			ShowYear = "";

		Loader.Format("%d", a);

		m_edit_data_name.ACAddString( &ActBirthFile.ActBirthPersons[a].Name);
		m_edit_data_event.ACAddString( &ActBirthFile.ActBirthPersons[a].Event);

		m_list_data.AddItem(
			ActImage,
			_T( extra + buffer2.Mid(1)),
			_T( ShowYear),
			_T( ActBirthFile.ActBirthPersons[a].Name),
			_T( ActBirthFile.ActBirthPersons[a].Event),
			_T( ActBirthFile.ActBirthPersons[a].Date.DateAsString),
			_T( Loader)
		);
	}//for all persons

	m_edit_data_name.SetWindowText("");
	m_edit_data_event.SetWindowText( "");
	m_edit_date_day.SetWindowText( "");
	m_edit_date_month.SetWindowText( "");
	m_edit_date_year.SetWindowText( "");
}//void CEditDlg::ListOut()





void CEditDlg::OnItemchangedListData(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;


	if(pNMListView->uOldState == 0)
	{
		int it = pNMListView->iItem;
		Loader = m_list_data.GetItemText(it,5);
		int a = atoi(Loader);
		m_list_data.SetSelectionMark(it);
		a = m_list_data.GetSelectionMark();
		if(a != -1)
		{
			
			m_edit_data_name.SetWindowText( m_list_data.GetItemText(a,2));
			m_edit_data_event.SetWindowText( m_list_data.GetItemText(a,3));

			int b = atoi( m_list_data.GetItemText(a,5));
			Loader.Format("%d", ActBirthFile.ActBirthPersons[b].Date.day);
			m_edit_date_day.SetWindowText(Loader);
			Loader.Format("%d", ActBirthFile.ActBirthPersons[b].Date.month);
			m_edit_date_month.SetWindowText(Loader);
			Loader = ActBirthFile.ActBirthPersons[b].Date.year;
			m_edit_date_year.SetWindowText(Loader);
		}
	}

	*pResult = 0;

}


void CEditDlg::OnButtonEditChange()
{
	CRect rect;//balloon
	CString strData = "";
	bool error = false;

	m_edit_date_day.GetWindowText( strData);
	if( atoi( strData) < 1 || atoi( strData) > 31)
	{
		GetDlgItem(IDC_EDIT_DATE_DAY)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_WRONGDATE);
		error = true;
		m_edit_date_day.SetFocus();
		m_edit_date_day.SetSel( 0, -1);
	}

	m_edit_date_month.GetWindowText(  strData);
	if( atoi( strData) < 1 || atoi( strData) > 12)
	{
		GetDlgItem(IDC_EDIT_DATE_MOTH)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_WRONGDATE);
		error = true;
		m_edit_date_month.SetFocus();
		m_edit_date_month.SetSel( 0, -1);
	}

	m_edit_date_year.GetWindowText( strData);
	CString strTest = "";
	strTest.Format( "%d", atoi( strData));
	if( strData != "?" && strData != "??" && strData != "???" && strData != "????" && strData != strTest)
	{
		GetDlgItem(IDC_EDIT_DATE_YEAR)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_WRONGDATE);
		error = true;
		m_edit_date_year.SetFocus();
		m_edit_date_year.SetSel( 0, -1);
	}

	m_edit_data_event.GetWindowText( strData);
	if( strData.IsEmpty())
	{
		GetDlgItem(IDC_EDIT_EVENT)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_NOEVENT);
		error = true;
		m_edit_data_event.SetFocus();
		m_edit_data_event.SetSel( 0, -1);
	}

	m_edit_data_name.GetWindowText( strData);
	if( strData.IsEmpty())
	{
		GetDlgItem(IDC_EDIT_NAME)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_NONAME);
		error = true;
		m_edit_data_name .SetFocus();
		m_edit_data_name.SetSel( 0, -1);
	}

	int it = m_list_data.GetSelectionMark();
	if(it != -1 && error == false)
	{
		int num = atoi( m_list_data.GetItemText(it,5));
		m_edit_data_name.GetWindowText( ActBirthFile.ActBirthPersons[num].Name);
			m_edit_data_name.ACAddString( &ActBirthFile.ActBirthPersons[num].Name);
		m_edit_data_event.GetWindowText( ActBirthFile.ActBirthPersons[num].Event);
			m_edit_data_name.ACAddString( &ActBirthFile.ActBirthPersons[num].Name);

		bSomethingChanged = true;

		bool Error;
		LPTSTR ErrorPos;
		CString Content, buffer, buffer2, extra, ShowYear;
		int ActImage;

		m_edit_date_day.GetWindowText( Content);
		m_edit_date_month.GetWindowText( Loader);
		Content = Content + "." + Loader;
		m_edit_date_year.GetWindowText( Loader);
		Content = Content + "." + Loader;
		ActBirthFile.StringToTime( &ActBirthFile.ActBirthPersons[num], &Content, &Error, &ErrorPos);
		ActBirthFile.CalcTimeDiff();

		m_list_data.SetItemText(it, 2, ActBirthFile.ActBirthPersons[num].Name);
		m_list_data.SetItemText(it, 3, ActBirthFile.ActBirthPersons[num].Event);
		m_list_data.SetItemText(it, 4, ActBirthFile.ActBirthPersons[num].Date.DateAsString);

		m_edit_data_name.SetWindowText( ActBirthFile.ActBirthPersons[num].Name);
		m_edit_data_event.SetWindowText( ActBirthFile.ActBirthPersons[num].Event);

		ActBirthFile.CalcTimeDiffOne( num);

		if(ActBirthFile.ActBirthPersons[num].daydifflast <= ActBirthFile.ShowLast && ActBirthFile.ActBirthPersons[num].daydifflast > 0)
		{
			buffer2.Format("%d", ActBirthFile.ActBirthPersons[num].daydifflast);
			buffer2 = "0" + buffer2;
			buffer.Format("%d", 1000 - ActBirthFile.ActBirthPersons[num].daydifflast);
			buffer = "0" + buffer;
			extra = "-";
			if(ActBirthFile.ActBirthPersons[num].daydifflast == 1)
				ActImage = 7;
			else if(ActBirthFile.ActBirthPersons[num].daydifflast == 2)
				ActImage = 8;
			else if(ActBirthFile.ActBirthPersons[num].daydifflast == 3)
				ActImage = 9;
			else
				ActImage = 3;
			ShowYear.Format("%d",ActBirthFile.ActBirthPersons[num].yeardiff - 1);
		}
		else
		{
			buffer.Format("%d", ActBirthFile.ActBirthPersons[num].daydiffnext);
			buffer = "1" + buffer;
			buffer2 = buffer;
			extra = " ";

			if(ActBirthFile.ActBirthPersons[num].daydiffnext == 0)
				ActImage = 0;
			else if(ActBirthFile.ActBirthPersons[num].daydiffnext == 1)
				ActImage = 4;
			else if(ActBirthFile.ActBirthPersons[num].daydiffnext == 2)
				ActImage = 5;
			else if(ActBirthFile.ActBirthPersons[num].daydiffnext == 3)
				ActImage = 6;
			else if(ActBirthFile.ActBirthPersons[num].daydiffnext <= 10)
				ActImage = 1;
			else
				ActImage = 2;

			ShowYear.Format("%d",ActBirthFile.ActBirthPersons[num].yeardiff);
		}

		if(ActBirthFile.ActBirthPersons[num].Date.year.Right(1) == "?")
			ShowYear = "";

		m_list_data.SetItemText(it, 0, extra + buffer2.Mid(1));
		m_list_data.SetItemText(it, 1, ShowYear);


		m_list_data.SetItem(it, 0, LVIF_IMAGE, "", ActImage, 0, 0, 0);

		CString strTitle;
		strTitle.LoadString( IDS_MSG_CHANGED);
		GetDlgItem(IDC_LIST_DATA)->GetWindowRect(&rect);
		CString strMsg = ActBirthFile.ActBirthPersons[num].Name + " - " + ActBirthFile.ActBirthPersons[num].Event + " - " + ActBirthFile.ActBirthPersons[num].Date.DateAsString;
		CBalloonHelp::LaunchBalloon( strTitle, strMsg, rect.CenterPoint(), IDI_INFORMATION, CBalloonHelp::unCLOSE_ON_MOUSE_MOVE | CBalloonHelp::unCLOSE_ON_KEYPRESS, NULL, "", 2000);

	}
	else if(error == true)
	{
		CBalloonHelp::LaunchBalloon( MSGBOXTITLE, Loader, rect.CenterPoint(), IDI_ERROR, CBalloonHelp::unCLOSE_ON_MOUSE_MOVE | CBalloonHelp::unCLOSE_ON_KEYPRESS, NULL, "", 0);
		//MessageBox( Loader, MSGBOXTITLE, MB_ICONERROR);
	}
}

void CEditDlg::OnButtonEditAdd()
{
	bool error = false;
	CString strData = "";
	CRect rect;//balloon

	m_edit_date_day.GetWindowText( strData);
	if( atoi( strData) < 1 || atoi( strData) > 31)
	{
		GetDlgItem(IDC_EDIT_DATE_DAY)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_WRONGDATE_DAY);
		error = true;
		m_edit_date_day.SetFocus();
		m_edit_date_day.SetSel( 0, -1);
	}

	m_edit_date_month.GetWindowText(  strData);
	if( atoi( strData) < 1 || atoi( strData) > 12)
	{
		GetDlgItem(IDC_EDIT_DATE_MOTH)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_WRONGDATE_MONTH);
		error = true;
		m_edit_date_month.SetFocus();
		m_edit_date_month.SetSel( 0, -1);
	}

	m_edit_date_year.GetWindowText( strData);
	CString strTest = "";
	strTest.Format( "%d", atoi( strData));
	if( strData != "?" && strData != "??" && strData != "???" && strData != "????" && strData != strTest)
	{
		GetDlgItem(IDC_EDIT_DATE_YEAR)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_WRONGDATE_YEAR);
		error = true;
		m_edit_date_year.SetFocus();
		m_edit_date_year.SetSel( 0, -1);
	}

	m_edit_data_event.GetWindowText( strData);
	if( strData.IsEmpty())
	{
		GetDlgItem(IDC_EDIT_EVENT)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_NOEVENT);
		error = true;
		m_edit_data_event.SetFocus();
		m_edit_data_event.SetSel( 0, -1);
	}

	m_edit_data_name.GetWindowText( strData);
	if( strData.IsEmpty())
	{
		GetDlgItem(IDC_EDIT_NAME)->GetWindowRect(&rect);
		Loader.LoadString( IDS_EDIT_NONAME);
		error = true;
		m_edit_data_name .SetFocus();
		m_edit_data_name.SetSel( 0, -1);
	}


	if(	ActBirthFile.CountPersons + 1 >= MAXBIRTHDAYS)
	{
		GetDlgItem(IDC_LIST_DATA)->GetWindowRect(&rect);
		Loader.LoadString(IDS_PARSE_ERROR_TOOMUCH);
		error = true;
	}

	if(error == false)
	{


		CString Content;
		CString strName, strEvent, strDate;

		m_edit_data_name.GetWindowText( strName);
				m_edit_data_name.ACAddString( &strName);
		m_edit_data_event.GetWindowText( strEvent);
				m_edit_data_event.ACAddString( &strEvent);

		m_edit_date_day.GetWindowText( Content);
		m_edit_date_month.GetWindowText( Loader);
		Content = Content + "." + Loader;
		m_edit_date_year.GetWindowText( Loader);
		Content = Content + "." + Loader;

		//check if already exists
		for( int nA = 0; nA <= ActBirthFile.CountPersons; nA++)
		{
			if( ActBirthFile.ActBirthPersons[ nA].Name.CompareNoCase( strName) == 0 &&
				ActBirthFile.ActBirthPersons[ nA].Event.CompareNoCase( strEvent) == 0)
			{
				Loader.LoadString( IDS_MSG_ALREADYEXISTS);
				CString strMsg;
				strMsg.Format( Loader, ActBirthFile.ActBirthPersons[ nA].Name + " - " + ActBirthFile.ActBirthPersons[ nA].Event + " - " + ActBirthFile.ActBirthPersons[ nA].Date.DateAsString, strName + " - " + strEvent + " - " + Content);
				if( MessageBox( strMsg, MSGBOXTITLE, MB_YESNO | MB_ICONQUESTION) == IDNO)
					return;
			}
				
		}
		
		ActBirthFile.AddPerson( strName, strEvent, Content);
		bSomethingChanged = true;
		ActBirthFile.CalcTimeDiffOne( ActBirthFile.CountPersons);


		int a = ActBirthFile.CountPersons;
		CString buffer, buffer2, extra, ShowYear;
		int ActImage;

		if(ActBirthFile.ActBirthPersons[a].daydifflast <= ActBirthFile.ShowLast && ActBirthFile.ActBirthPersons[a].daydifflast > 0)
		{
			buffer2.Format("%d", ActBirthFile.ActBirthPersons[a].daydifflast);
			buffer2 = "0" + buffer2;
			buffer.Format("%d", 1000 - ActBirthFile.ActBirthPersons[a].daydifflast);
			buffer = "0" + buffer;
			extra = "-";
			if(ActBirthFile.ActBirthPersons[a].daydifflast == 1)
				ActImage = 7;
			else if(ActBirthFile.ActBirthPersons[a].daydifflast == 2)
				ActImage = 8;
			else if(ActBirthFile.ActBirthPersons[a].daydifflast == 3)
				ActImage = 9;
			else
				ActImage = 3;
			ShowYear.Format("%d",ActBirthFile.ActBirthPersons[a].yeardiff - 1);
		}
		else
		{
			buffer.Format("%d", ActBirthFile.ActBirthPersons[a].daydiffnext);
			buffer = "1" + buffer;
			buffer2 = buffer;
			extra = " ";

			if(ActBirthFile.ActBirthPersons[a].daydiffnext == 0)
				ActImage = 0;
			else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 1)
				ActImage = 4;
			else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 2)
				ActImage = 5;
			else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 3)
				ActImage = 6;
			else if(ActBirthFile.ActBirthPersons[a].daydiffnext <= 10)
				ActImage = 1;
			else
				ActImage = 2;

			ShowYear.Format("%d",ActBirthFile.ActBirthPersons[a].yeardiff);
		}

		if(ActBirthFile.ActBirthPersons[a].Date.year.Right(1) == "?")
			ShowYear = "";

		CString strNum;
		strNum.Format( "%d", a);
		int nPos = m_list_data.AddItem(
			ActImage,
			_T( buffer2.Mid(1)),
			_T( ShowYear),
			_T( ActBirthFile.ActBirthPersons[a].Name),
			_T( ActBirthFile.ActBirthPersons[a].Event),
			_T( ActBirthFile.ActBirthPersons[a].Date.DateAsString),
			_T( strNum)
		);

		m_edit_data_name.SetFocus();
		m_edit_data_name.SetSel( 0, -1);

		
		GetDlgItem(IDC_LIST_DATA)->GetWindowRect(&rect);
		CString strMsg = ActBirthFile.ActBirthPersons[a].Name + " - " + ActBirthFile.ActBirthPersons[a].Event + " - " + ActBirthFile.ActBirthPersons[a].Date.DateAsString;
		CString strTitle;
		strTitle.LoadString( IDS_MSG_ADDED);
		//IDS_MSG_ADDED
		CBalloonHelp::LaunchBalloon( strTitle, strMsg, rect.CenterPoint(), IDI_INFORMATION, CBalloonHelp::unCLOSE_ON_MOUSE_MOVE | CBalloonHelp::unCLOSE_ON_KEYPRESS, NULL, "", 2000);
	}//no errror
	else if(error == true)
	{
		CBalloonHelp::LaunchBalloon( MSGBOXTITLE, Loader, rect.CenterPoint(), IDI_ERROR, CBalloonHelp::unCLOSE_ON_MOUSE_MOVE | CBalloonHelp::unCLOSE_ON_KEYPRESS, NULL, "", 0);
		//MessageBox( Loader, MSGBOXTITLE, MB_ICONERROR);
	}

}

void CEditDlg::OnButtonEditDelete()
{
	int it = m_list_data.GetSelectionMark();
	if(it != -1)
	{
		CString strLoader2;
		Loader.LoadString( IDS_EDIT_DELETEREAL);
		int nArNum = atoi( m_list_data.GetItemText( it, 5));
		strLoader2.Format( Loader, ActBirthFile.ActBirthPersons[nArNum].Name + " - " + ActBirthFile.ActBirthPersons[nArNum].Event + " - " + ActBirthFile.ActBirthPersons[nArNum].Date.DateAsString);

		int ant = MessageBox( strLoader2, MSGBOXTITLE, MB_YESNO + MB_ICONQUESTION);
		if(ant == IDYES)
		{
			int lastperson = ActBirthFile.CountPersons;
			Loader = m_list_data.GetItemText(it, 5);
			int itnum = atoi(Loader);

			if(itnum < lastperson)
			{
				ActBirthFile.ActBirthPersons[itnum] = ActBirthFile.ActBirthPersons[lastperson];
				ActBirthFile.ActBirthPersons[lastperson].yeardiff = 0;
				ActBirthFile.ActBirthPersons[lastperson].Name = "";
				ActBirthFile.ActBirthPersons[lastperson].Event = "";
				ActBirthFile.ActBirthPersons[lastperson].daydiffnext = 0;
				ActBirthFile.ActBirthPersons[lastperson].daydifflast = 0;
				ActBirthFile.ActBirthPersons[lastperson].Date.DateAsString = "";
				ActBirthFile.ActBirthPersons[lastperson].Date.day = 0;
				ActBirthFile.ActBirthPersons[lastperson].Date.month = 0;
				ActBirthFile.ActBirthPersons[lastperson].Date.year = "0";

				int num;
				for(int a = 0; a < lastperson; a++)
				{
					Loader = m_list_data.GetItemText(a, 3);
					num = atoi(Loader);
					if(num == lastperson)
					{
						Loader.Format("%d", itnum);
						m_list_data.SetItemText(a,3, Loader);
						break;
					}
				}

			}
			m_list_data.DeleteItem(it);
			ActBirthFile.CountPersons --;

			bSomethingChanged = true;
		}//YES
	}
	m_list_data.SetFocus();
}

void CEditDlg::OnButtonEditReload()
{
	ListOut();
}

void CEditDlg::OnButtonSelfile()
{
	bool bOpenFileDialog = false;
	LPCTSTR lpszDefExt = "*.bdf";
	LPCTSTR lpszFileName = "";
	DWORD dwFlags = OFN_HIDEREADONLY ;
	Loader.LoadString(IDS_FILTER_OPEN);
	LPCTSTR	lpszFilter = Loader;
	CWnd* pParentWnd = 0;

	CFileDialog FileDlg(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd);

	if(ActBirthFile.FileName = "")
		FileDlg.m_ofn.lpstrInitialDir = __argv[0];
	else
		FileDlg.m_ofn.lpstrInitialDir = ActBirthFile.FileName;

	int ant = FileDlg.DoModal();

	if(ant == IDOK)
	{
		CString FileName = FileDlg.GetPathName();

		m_label_file.SetWindowText( FileName);
		ActBirthFile.FileName = FileName;
	}
}

// Save + Exit EditDlg
void CEditDlg::OnOK()
{
	m_edit_back.GetWindowText( Loader);
	int num = atoi(Loader);
	if(num > 365 || num < 0)
	{
		Loader.LoadString(IDS_EDIT_WRONGBACK);
		MessageBox(Loader,MSGBOXTITLE, MB_ICONERROR);
		return;
	}
	else
		ActBirthFile.ShowLast = num;

	m_edit_for.GetWindowText( Loader);
	num = atoi(Loader);
	if(num > 365 || num < 0)
	{
		Loader.LoadString(IDS_EDIT_WRONGFOR);
		MessageBox(Loader,MSGBOXTITLE, MB_ICONERROR);
		return;
	}
	else
		ActBirthFile.ShowNext = num;

	m_edit_info_title.GetWindowText( ActBirthFile.Title);
	m_edit_info_author.GetWindowText( ActBirthFile.Author);
	m_edit_info_version.GetWindowText( ActBirthFile.Version);

	SaveBirtdayFile();
	CDialog::OnOK();
}



int CEditDlg::SaveBirtdayFile()
{
	ActBirthFile.Content = "";
	ActBirthFile.CreateContent( false, "rdbirthdayfile", "");

	_unlink(ActBirthFile.FileName); //deletes the file
	CStdioFile BirthdayFile;
	CFileException e;
	if(!BirthdayFile.Open(ActBirthFile.FileName, CFile::modeWrite | CFile::typeText | CFile::modeCreate, &e))
	{
		CString ErrText, ErrTitle;
		ErrText.LoadString(IDS_PARSE_FILEOPEN_ERROR_TEXT);
		ErrTitle.LoadString(IDS_PARSE_FILEOPEN_ERROR_TITLE);
		MessageBox( ErrText + ActBirthFile.FileName, MSGBOXTITLE, 0 + MB_ICONSTOP );
		return 0;
	}
	BirthdayFile.WriteString(ActBirthFile.Content + "\0");

	BirthdayFile.Close();

	return 1;
}


void CEditDlg::OnButtonImport()
{
	ShowPortDlg(true, "rdbirthdayfile");

}

void CEditDlg::OnButtonExport()
{
	ShowPortDlg(false, "rdbirthdayfile");

}

////////TYPES///////////
//	"rdbirthdayfile"
//  "html"
//  "csv"

void CEditDlg::ShowPortDlg(bool Import, LPTSTR Type)
{
	CPortDlg PortWindow;
	PortWindow.ActBirthFile.InitVariables();
	PortWindow.PortImport = Import;
	PortWindow.PortType = Type;

	PortWindow.IsMagnetOn = IsMagnetOn;
	PortWindow.IsOnTop = IsOnTop;

	PortWindow.strHelpfile = strHelpfile;

	PortWindow.ParentBirthFile = &ActBirthFile;
	if( !Import)
	{
		PortWindow.ActBirthFile = ActBirthFile;
	}


	int ant = PortWindow.DoModal();
	if( ant == IDOK)
	{
		if( Import)
		{
			bool error = false;
			for( int a = 0; a <= PortWindow.ActBirthFile.CountPersons; a++)
			{
				if( PortWindow.ActBirthFile.ActBirthPersons[a].Checked)
				{
					if(	ActBirthFile.CountPersons + 1 < MAXBIRTHDAYS)
					{
						ActBirthFile.CountPersons++;
						ActBirthFile.ActBirthPersons[ ActBirthFile.CountPersons] = PortWindow.ActBirthFile.ActBirthPersons[a];
						bSomethingChanged = true;
					}
					else
					{
						error = true;
						break;
					}
				}
			}

			if( error == true)
			{
				Loader.LoadString(IDS_PARSE_ERROR_TOOMUCH);
				MessageBox( Loader, MSGBOXTITLE, MB_ICONERROR);
			}
			ActBirthFile.CalcTimeDiff();
			ListOut();
		}//end import
		else//export: show filedlg
		{
			bool bOpenFileDialog = false;
			LPCTSTR lpszDefExt = "*.bdf";
			LPCTSTR lpszFileName = "";
			DWORD dwFlags = OFN_HIDEREADONLY + OFN_OVERWRITEPROMPT;

			Loader.LoadString(IDS_FILTER_EXPORT);
			LPCTSTR lpszFilter = Loader;

			CWnd* pParentWnd = 0;

			CFileDialog FileDlg(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd);

			if(ActBirthFile.FileName == "")
				FileDlg.m_ofn.lpstrInitialDir = __argv[0];
			else
				FileDlg.m_ofn.lpstrInitialDir = ActBirthFile.FileName;

			int ant = FileDlg.DoModal();

			if(ant == IDOK)
			{
				Loader = FileDlg.GetFileExt();
				Loader.MakeLower();
				if(Loader == "htm" || Loader == "html")
					Type = "html";
				else if(Loader == "bdf")
					Type = "rdbirthdayfile";
				else if( Loader == "csv")
					Type = "csv";

				PortWindow.ActBirthFile.CreateContent(true, Type, Loader );

				CStdioFile BirthdayFile;
				CFileException e;
				_unlink(FileDlg.GetPathName());
				if(!BirthdayFile.Open( FileDlg.GetPathName(), CFile::modeWrite | CFile::typeText | CFile::modeCreate, &e))
				{
					CString ErrText, ErrTitle;
					ErrText.LoadString(IDS_PARSE_FILEOPEN_ERROR_TEXT);
					ErrTitle.LoadString(IDS_PARSE_FILEOPEN_ERROR_TITLE);
					MessageBox(ErrText, MSGBOXTITLE, 0 + MB_ICONSTOP );
					return;
				}
				BirthdayFile.WriteString(PortWindow.ActBirthFile.Content + "\0");

				BirthdayFile.Close();

			}

		}//end export

	}//end IDOK
}


void CEditDlg::OnButtonEditDeleteall()
{
		Loader.LoadString( IDS_EDIT_DELETEALLREAL);
		int ant = MessageBox( Loader, MSGBOXTITLE, MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON2);
		if(ant == IDYES)
		{
			ActBirthFile.ClearData();
			ActBirthFile.CountPersons = -1;
			m_list_data.DeleteAllItems();
			bSomethingChanged = true;
		}
}


void CEditDlg::OnSysCommand(UINT nID, LPARAM lParam)
{

	if(nID == IDM_MNU_MAGNET)
		ChangeMagnetBorder();
	else if(nID == IDM_MNU_ONTOP)
		ChangeOnTop();
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CEditDlg::OnMoving(UINT nSide, LPRECT lpRect)
{
	if(IsLoaded == true && IsMagnetOn == true && GetAsyncKeyState(VK_CONTROL) == 0 && GetAsyncKeyState(VK_SHIFT) == 0)
	{
		NewPos = lpRect;
		GetWindowRect(WindowPos);

		WindowSize.right = NewPos->right - NewPos->left;
		WindowSize.bottom = NewPos->bottom - NewPos->top;

		SystemParametersInfo(SPI_GETWORKAREA,0,ScreenSize,0);

		RealPos.top = RealPos.top - WindowPos.top + NewPos->top;
		RealPos.left = RealPos.left - WindowPos.left + NewPos->left;
		RealPos.bottom = RealPos.top + WindowSize.bottom;
		RealPos.right = RealPos.left + WindowSize.right;


		if(!(abs(ScreenSize.top + RealPos.top) <= MagnetSize))
		{
			if(MagnetOnTop)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnTop = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->top = ScreenSize.top;
			NewPos->bottom = NewPos->top + WindowSize.bottom;
			MagnetOnTop = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.left + RealPos.left) <= MagnetSize))
		{
			if(MagnetOnLeft)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnLeft = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->left = ScreenSize.left;
			NewPos->right = NewPos->left + WindowSize.right;
			MagnetOnLeft = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.bottom - RealPos.bottom) <= MagnetSize))
		{
			if(MagnetOnBottom)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnBottom = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->bottom = ScreenSize.bottom;
			NewPos->top = NewPos->bottom - WindowSize.bottom;
			MagnetOnBottom = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.right - RealPos.right) <= MagnetSize))
		{
			if(MagnetOnRight)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnRight = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->right = ScreenSize.right;
			NewPos->left = NewPos->right - WindowSize.right;
			MagnetOnRight = true;
			MagnetNowOn = true;
		}


		if(MagnetNowOn)
		{
			lpRect = NewPos;
			MagnetNowOn = false;
		}
		else
		{
			GetWindowRect(RealPos);
		}

	}
	else
	{
		GetWindowRect(RealPos);
	}

	CDialog::OnMoving(nSide, lpRect);

	if(!IsLoaded)
	{
		GetWindowRect(RealPos);
		MagnetOnTop = false;
		MagnetOnLeft = false;
		MagnetOnRight = false;
		MagnetOnBottom = false;
		IsLoaded = true;

	}
}

void CEditDlg::ChangeMagnetBorder()
{
	IsMagnetOn = !IsMagnetOn;

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		if(IsMagnetOn)
			pSysMenu->CheckMenuItem(IDM_MNU_MAGNET,MF_CHECKED);
		else
			pSysMenu->CheckMenuItem(IDM_MNU_MAGNET,MF_UNCHECKED);
	}

}

void CEditDlg::ChangeOnTop()
{
	IsOnTop = !IsOnTop;

	if(IsOnTop)
		CDialog::SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE + SWP_NOMOVE);
	else
		CDialog::SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_NOSIZE + SWP_NOMOVE);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		if(IsOnTop)
			pSysMenu->CheckMenuItem(IDM_MNU_ONTOP,MF_CHECKED);
		else
			pSysMenu->CheckMenuItem(IDM_MNU_ONTOP,MF_UNCHECKED);
	}

}

void CEditDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	GetWindowRect(RealPos);
}



BOOL CEditDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
	CString strMsg;
	CRect rect;
	//switch between context help and real help
	switch (pHelpInfo->iCtrlId)
	{
		case IDC_EDIT_NAME:
			GetDlgItem(IDC_EDIT_NAME)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_LIST_HEADER_NAME);
			break;

		case IDC_EDIT_EVENT:
			GetDlgItem(IDC_EDIT_EVENT)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_LIST_HEADER_EVENT);
			break;

		case IDC_EDIT_DATE_DAY:
			GetDlgItem(IDC_EDIT_DATE_DAY)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_EDIT_DAY);
			break;

		case IDC_EDIT_DATE_MOTH:
			GetDlgItem(IDC_EDIT_DATE_MOTH)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_EDIT_MONTH);
			break;

		case IDC_EDIT_DATE_YEAR:
			GetDlgItem(IDC_EDIT_DATE_YEAR)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_EDIT_YEAR);
			break;


		default:
			CFileStatus FileStatus;
			//if file exists, try to show dialog
			if( CFile::GetStatus( strHelpfile, FileStatus) != 0)
			{

				HWND hwndHelp = HtmlHelp( m_hWnd, strHelpfile + "::/102 - edit.htm>Main", HH_DISPLAY_TOPIC, NULL);
			}
			//No help file? Show about dialog
			else
			{
				CAboutDlg dlgAbout;
				dlgAbout.DoModal();
			}

			return 0;
	}
	CBalloonHelp::LaunchBalloon(MSGBOXTITLE, strMsg, rect.CenterPoint(), IDI_INFORMATION, CBalloonHelp::unCLOSE_ON_MOUSE_MOVE | CBalloonHelp::unCLOSE_ON_KEYPRESS);

	return true;
}


void CEditDlg::OnKeydownListData(NMHDR* pNMHDR, LRESULT* pResult)
{
	//LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;

	if( GetKeyState( VK_DELETE) & 0x8000 )
	{
		OnButtonEditDelete();
	}

	*pResult = 0;
}

//Name-Feld erhlt Fokus -> "Add" als standardfeld
void CEditDlg::OnSetfocusEditName()
{
	m_button_save.SetButtonStyle( BS_PUSHBUTTON, true);
	int nTest = m_button_edit_add.GetDlgCtrlID();
	SetDefID( nTest);
	m_button_edit_add.SetButtonStyle( BS_DEFPUSHBUTTON, true);

}

void CEditDlg::OnKillfocusEditName()
{
	SetDefID( m_button_save.GetDlgCtrlID());
}


//Wenn 2 Zeichen eingegeben, dann zu Monat springen
void CEditDlg::OnChangeEditDateDay() 
{
	int nStart, nEnd;

	m_edit_date_day.GetSel( nStart, nEnd);
	if( nStart == 2 && nEnd == 2)
	{
		//check if day is in 1-31
		CString strTmp;
		m_edit_date_day.GetWindowText( strTmp);
		int nA = atoi( strTmp);
		if( nA >= 1 && nA <= 31)
		{
			m_edit_date_month.SetFocus();
			m_edit_date_month.SetSel( 0, -1, true);
		}
	}
}

void CEditDlg::OnChangeEditDateMoth() 
{
	int nStart, nEnd;

	m_edit_date_month.GetSel( nStart, nEnd);
	if( nStart == 2 && nEnd == 2)
	{
		//check if month is in 1-12
		CString strTmp;
		m_edit_date_month.GetWindowText( strTmp);
		int nA = atoi( strTmp);
		if( nA >= 1 && nA <= 12)
		{
			m_edit_date_year.SetFocus();
			m_edit_date_year.SetSel( 0, -1, true);
		}
	}
	
}

BOOL CEditDlg::PreTranslateMessage(MSG* pMsg) 
{
	CEdit* pEditDateDay = (CEdit*)GetDlgItem(IDC_EDIT_DATE_DAY);
	CEdit* pEditDateMonth = (CEdit*)GetDlgItem(IDC_EDIT_DATE_MOTH);
	CEdit* pEditDateYear = (CEdit*)GetDlgItem(IDC_EDIT_DATE_YEAR);
	CString strTemp;
	bool bSetSel = false;

	if ((CEdit*)this->GetFocus() == pEditDateDay)
	{
		if (pMsg->message == WM_KEYDOWN) 
		{
			if( pMsg->wParam == VK_RIGHT)
			{
				int nStart, nEnd, nLength;
				m_edit_date_day.GetSel( nStart, nEnd);
				nLength = m_edit_date_day.GetWindowTextLength();
				if( nLength == nStart && nLength == nEnd)
				{
					m_edit_date_month.SetFocus();
					m_edit_date_month.SetSel( 0, 0);
					return TRUE;
				}
			}//Rechts
			else if( pMsg->wParam == VK_UP)
			{
				m_edit_date_day.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n++;
				if( n > 31)
					n = 31;
				else if( n < 1)
					n = 1;
				strTemp.Format( "%d", n);
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_DOWN)
			{
				m_edit_date_day.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n--;
				if( n < 1)
					n = 1;
				else if( n > 31)
					n= 31;

				strTemp.Format( "%d", n);
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_HOME)
			{
				strTemp = "1";
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_END)
			{
				strTemp = "31";
				bSetSel = true;
			}
			else if( pMsg->wParam == 0x21)//Page Up
			{
				m_edit_date_day.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n = n + 5;
				if( n > 31)
					n = 31;
				else if( n < 1)
					n = 1;
				strTemp.Format( "%d", n);
				bSetSel = true;
			}
			else if( pMsg->wParam == 0x22)//Page Down
			{
				m_edit_date_day.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n = n - 5;
				if( n < 1)
					n = 1;
				else if( n > 31)
					n= 31;

				strTemp.Format( "%d", n);
				bSetSel = true;
			}

			if( bSetSel)
			{
				m_edit_date_day.SetWindowText( strTemp);
				m_edit_date_day.SetSel( 0, -1);
				return TRUE;
			}
		}//keydown
	}
	else if ((CEdit*)this->GetFocus() == pEditDateMonth)
	{
		if (pMsg->message == WM_KEYDOWN) 
		{
			if ( pMsg->wParam == VK_RIGHT) 
			{
				int nStart, nEnd, nLength;
				m_edit_date_month.GetSel( nStart, nEnd);
				nLength = m_edit_date_month.GetWindowTextLength();
				if( nLength == nStart && nLength == nEnd)
				{
					m_edit_date_year.SetFocus();
					m_edit_date_year.SetSel( 0, 0);
					return TRUE;
				}
			}
			else if ( pMsg->wParam == VK_LEFT) 
			{
				int nStart, nEnd, nLength;
				m_edit_date_month.GetSel( nStart, nEnd);
				if( nStart == 0 && nEnd == 0)
				{
					nLength = m_edit_date_day.GetWindowTextLength();
					m_edit_date_day.SetFocus();
					m_edit_date_day.SetSel( nLength, nLength);
					return TRUE;
				}
			}
			else if( pMsg->wParam == VK_UP)
			{
				m_edit_date_month.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n++;
				if( n > 12)
					n = 12;
				else if( n < 1)
					n = 1;
				strTemp.Format( "%d", n);
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_DOWN)
			{
				m_edit_date_month.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n--;
				if( n < 1)
					n = 1;
				else if( n > 12)
					n= 12;

				strTemp.Format( "%d", n);
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_HOME)
			{
				strTemp = "1";
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_END)
			{
				strTemp = "12";
				bSetSel = true;
			}

			if( bSetSel)
			{
				m_edit_date_month.SetWindowText( strTemp);
				m_edit_date_month.SetSel( 0, -1);
				return TRUE;
			}
		}//keydown
	}
	else if( (CEdit*)this->GetFocus() == pEditDateYear)
	{
		if( pMsg->message == WM_KEYDOWN) 
		{
			if( pMsg->wParam == VK_LEFT)
			{
				int nStart, nEnd, nLength;
				m_edit_date_year.GetSel( nStart, nEnd);
				if( nStart == 0&& nEnd == 0)
				{
					nLength = m_edit_date_month.GetWindowTextLength();
					m_edit_date_month.SetFocus();
					m_edit_date_month.SetSel( nLength, nLength);
					return TRUE;
				}
			}
			else if( pMsg->wParam == VK_UP)
			{
				m_edit_date_year.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n++;
				if( n < 0)
					n = 0;
				strTemp.Format( "%d", n);
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_DOWN)
			{
				m_edit_date_year.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n--;
				if( n < 0)
					n = 0;

				strTemp.Format( "%d", n);
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_HOME)
			{
				//unknown
				strTemp = "????";
				bSetSel = true;
			}
			else if( pMsg->wParam == VK_END)
			{
				//current year
				COleDateTime tmTime;
				tmTime = COleDateTime::GetCurrentTime();
				strTemp.Format( "%d", tmTime.GetYear()); 
				bSetSel = true;
			}
			else if( pMsg->wParam == 0x21)//VK_PAGE_UP
			{
				m_edit_date_year.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n = n + 10;
				if( n < 0)
					n = 0;
				strTemp.Format( "%d", n);
				bSetSel = true;
			}
			else if( pMsg->wParam == 0x22)//VK_PAGE_DOWN
			{
				m_edit_date_year.GetWindowText( strTemp);
				int n = atoi( strTemp);
				n = n - 10;
				if( n < 0)
					n = 0;

				strTemp.Format( "%d", n);
				bSetSel = true;
			}

			if( bSetSel)
			{
				m_edit_date_year.SetWindowText( strTemp);
				m_edit_date_year.SetSel( 0, -1);
				return TRUE;
			}
		}//keydown
	}

	//just let other messages to work normally
	return CDialog::PreTranslateMessage(pMsg);
}

void CEditDlg::OnChangeEditInfoTitle() 
{
	bSomethingChanged = true;
}

void CEditDlg::OnChangeEditInfoAuthor() 
{
	bSomethingChanged = true;
}

void CEditDlg::OnChangeEditInfoVersion() 
{
	bSomethingChanged = true;
}

void CEditDlg::OnCancel() 
{
	if( bSomethingChanged == true)
	{
		Loader.LoadString( IDS_MSG_SAVECHANGES);
		if( MessageBox( Loader, MSGBOXTITLE, MB_YESNO | MB_ICONQUESTION) == IDYES)
		{
			OnOK();
		}
		else
			CDialog::OnCancel();
	}
	else
		CDialog::OnCancel();
}

void CEditDlg::OnItemclickListData(NMHDR* pNMHDR, LRESULT* pResult) 
{
MessageBox( "ma");	
	//HD_NOTIFY *phdn = (HD_NOTIFY *) pNMHDR;
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	CMenu mnuDatePopUp, *mnuSubMenu;
	mnuDatePopUp.LoadMenu( IDR_MENU_POPUP);
	mnuSubMenu = mnuDatePopUp.GetSubMenu( 0);

    CPoint pos;
    GetCursorPos(&pos);
	TrackPopupMenu( mnuSubMenu->m_hMenu, 0, pos.x, pos.y, 0, m_hWnd, NULL);


	*pResult = 0;
}

void CEditDlg::OnHeaderItemclickListData(NMHDR* pNMHDR, LRESULT* pResult) 
{
	HD_NOTIFY *phdn = (HD_NOTIFY *) pNMHDR;
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen

	POINT Point;
	GetCursorPos (&Point);
	m_list_data.ScreenToClient(&Point);

	HDHITTESTINFO HitTest;
      
	//Offset of right scrolling 
	HitTest.pt.x = Point.x+ m_list_data.GetScrollPos(SB_HORZ); //Offset of right scrolling
	HitTest.pt.y = Point.y;

	//Send the Hit Test Message
	m_list_data.GetHeaderCtrl()->SendMessage(HDM_HITTEST,0,(LPARAM)&HitTest);

	//popup only if the date column was right-clicked
	if( HitTest.iItem == 4)
	{
		CMenu mnuDatePopUp, *mnuSubMenu;
		mnuDatePopUp.LoadMenu( IDR_MENU_POPUP);
		mnuSubMenu = mnuDatePopUp.GetSubMenu( 0);
		mnuSubMenu->CheckMenuRadioItem(0, 2, m_list_data.nDatesort, MF_BYPOSITION);

		CPoint pos;
		GetCursorPos(&pos);
		TrackPopupMenu( mnuSubMenu->m_hMenu, 0, pos.x, pos.y, 0, m_hWnd, NULL);
		
	}
	
	*pResult = 0;
}

////////////////////////////////////////
// just for "sort by date" handling
void CEditDlg::OnMenuSortdatebyDay() 
{
	m_list_data.nDatesort = 0;
}

void CEditDlg::OnMenuDatesortYear() 
{
	m_list_data.nDatesort = 2;
}

void CEditDlg::OnMenuSortdatebyMonth() 
{
	m_list_data.nDatesort = 1;
}
